using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;



namespace DestCode
{
    public partial class Client : Form
        
    {
     
        public Client()
        {
            InitializeComponent();
            DestCode.receivedPath = "";
        }
        
       private void timer1_Tick(object sender, EventArgs e)
        {
            label5.Text = DestCode.receivedPath;
            lblres.Text = DestCode.curMsg;
            txtReceivedchecksum.Text = DestCode.checksumvalue;
            txtFilePath.Text=DestCode.OpenFilePath;
        }

        DestCode obj = new DestCode();
        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            
            obj.StartServer();            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            backgroundWorker1.RunWorkerAsync();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog f = new FolderBrowserDialog();
            f.ShowDialog();
            if (f.SelectedPath != "")
            {
                DestCode.receivedPath = f.SelectedPath;
                label5.Text = f.SelectedPath;
            }
            else
            {
                MessageBox.Show("Please Select a File Receiving Path.\r\n Else You Can not Receive the File");
            }
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            
        }
        private void btnReceivePath_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog f = new FolderBrowserDialog();
            f.ShowDialog();
            if (f.SelectedPath != "")
            {
                DestCode.receivedPath = f.SelectedPath;
                label5.Text = f.SelectedPath;
            }
            else
            {
                MessageBox.Show("Please Select a File Receiving Path.\r\n Else You Can not Receive the File");
            }
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            if (txtFilePath.Text != "")
            {
                AdlerChecksum checksum = new AdlerChecksum();
                if (checksum.MakeForFile(txtFilePath.Text))
                {

                    txtfilechecksum.Text = checksum.ToString();

                }
                else
                {
                    MessageBox.Show("Unable to Calculate the Checksum Valuie", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
         }

        private void btnValidate_Click(object sender, EventArgs e)
        {
            if (txtReceivedchecksum.Text == txtfilechecksum.Text)
            {
                MessageBox.Show("Successfully Received Full Data", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information);

            }
            else
            {

                MessageBox.Show("Founded, File Has been corrupted", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Information);

            }
            Chart c = new Chart();
            c.Receivedval[0] = Convert.ToDouble(txtReceivedchecksum.Text );
            c.Receivedval[1] = Convert.ToDouble(txtfilechecksum.Text);
            c.txt[0] = "ReceivedCheckSum";
            c.txt[1] = "EvaluatedCheckSum";
            c.Show();
        }
      
    }
   
    class DestCode
    {
        IPEndPoint ipEnd;
        Socket sock;
        public DestCode()
        {
            IPHostEntry ipEntry = Dns.GetHostEntry(Environment.MachineName);
            IPAddress IpAddr = ipEntry.AddressList[0];
            ipEnd = new IPEndPoint(IpAddr, 5001);
           sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
           sock.Bind(ipEnd);
        }
        public static string receivedPath;
        public static string curMsg = "";
        public static string checksumvalue = "";
        public static string OpenFilePath = "";
        public  void StartServer()
        {
            try
            {
               
                sock.Listen(100);
                Socket clientSock = sock.Accept();
                byte[] Receivedata = new byte[1024 * 5000];
                int receivedBytesLen = clientSock.Receive(Receivedata);
                curMsg = "Receiving data...";
                int checksumLen = BitConverter.ToInt32(Receivedata, 0);
                checksumvalue = Encoding.ASCII.GetString(Receivedata, 4, checksumLen);
                int filenameLen = BitConverter.ToInt32(Receivedata, checksumLen+4);
                string filename = Encoding.ASCII.GetString(Receivedata, checksumLen + 8, filenameLen);

                BinaryWriter bWrite = new BinaryWriter(File.Open(receivedPath + "/" + filename, FileMode.Append));
                bWrite.Write(Receivedata, 8 + checksumLen+filenameLen , receivedBytesLen - (8 + checksumLen + filenameLen));
                if (receivedPath == "")
                {
                    MessageBox.Show("No Path was selected to Save the File");
                }
                bWrite.Close();
                OpenFilePath=receivedPath+"/"+filename;
                clientSock.Close();
               
 
                StartServer();
               
            }
            catch (Exception ex)
            {
                curMsg = "File Receving error.";
            }
        }
      
            
        }
    }
